﻿// This file is part of BenLincoln.DebugSymbols.

// BenLincoln.DebugSymbols is free software: you can redistribute it and/or modify
// it under the terms of version 3 of the GNU General Public License as published by
// the Free Software Foundation.

// BenLincoln.DebugSymbols is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with BenLincoln.DebugSymbols (in the file LICENSE.txt).  
// If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using BenLincoln.DebugSymbols.SymDump;

namespace BenLincoln.DebugSymbols
{
    public class FunctionSourceTracker
    {
        public Dictionary<string, List<CFunction>> SourceFiles;
        public FunctionSourceTracker()
        {
            SourceFiles = new Dictionary<string, List<CFunction>>();
        }

        public void AddOrUpdateEntry(CFunction func)
        {
            if (SourceFiles.ContainsKey(func.source_file))
            {
                SourceFiles[func.source_file].Add(func);
            }
            else
            {
                List<CFunction> newList = new List<CFunction>();
                newList.Add(func);
                SourceFiles.Add(func.source_file, newList);
            }
        }
    }
}
